﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;


// .NET Core 3.0 + C# 8.0
class Program
{
    static async Task Main(string[] args)
    {
        await foreach (int value in GenerateSequence(10))
        {
            Console.WriteLine($"{value} (tid: {Thread.CurrentThread.ManagedThreadId})");
        }

        Console.WriteLine($"Completed (tid: {Thread.CurrentThread.ManagedThreadId})");
    }

    public static async IAsyncEnumerable<int> GenerateSequence(int count)
    {
        for (int i = 0; i < count; i++)
        {
            await Task.Run(() => Thread.Sleep(100));
            yield return i;
        }
    }
}
